FUNCTION_BLOCK CounterST
  VAR_INPUT
    Reset : BOOL;
  END_VAR
  VAR_OUTPUT
    Out1 : INT;
    Out0 : INT;
  END_VAR
  VAR
    Cnt0 : INT;
  END_VAR
  VAR_EXTERNAL
    ResetCounterValue : INT;
    OI_sensor_counter : LREAL;
    VFD_relay0 : DINT;
    Air_Valve_Relay0 : DINT;
    MES5_int_counter_in : LINT;
    MES5_int_counter_out : LINT;
  END_VAR

  (* this will always switch on VFD_relay0 which controls conveyor line*)
  VFD_relay0 := 1;

  IF OI_sensor_counter=2.0 THEN
    (* a rectangle was recognized thus switch ON air valve *)
    Air_Valve_Relay0 := 1;
    (* read from MES5 counter value so we continue from where we were. In this case 
    increment blow counter at MES5*)
    MES5_int_counter_in := MES5_int_counter_in + 1;
    (* set to MES5 the counter value so it is kept permanently *)
    MES5_int_counter_out := MES5_int_counter_in;
  END_IF;

  IF  OI_sensor_counter=0.0 OR OI_sensor_counter=1.0 OR OI_sensor_counter=3.0 THEN
    (* a circle / triangle or nothing was recognized thus switch OFF air valve *)
    Air_Valve_Relay0 := 0;
  END_IF;

END_FUNCTION_BLOCK

PROGRAM plc_prg
  VAR_INPUT
    Reset : BOOL;
  END_VAR
  VAR_OUTPUT
    Cnt0 : INT;
    Cnt1 : INT;
  END_VAR
  VAR
    CounterST0 : CounterST;
  END_VAR

  CounterST0(Reset := Reset);
  Cnt1 := CounterST0.Out1;
  Cnt0 := CounterST0.Out0;
END_PROGRAM


CONFIGURATION config
  VAR_GLOBAL
    ResetCounterValue : INT := 0;
    OI_sensor_counter AT %IL1.2 : LREAL;
    VFD_relay0 AT %QD0.0 : DINT;
    Air_Valve_Relay0 AT %QD0.1 : DINT;
    MES5_int_counter_in AT %IL2.2 : LINT;
    MES5_int_counter_out AT %QL2.2 : LINT;
  END_VAR
  VAR_GLOBAL
    pyext_csv_update : BOOL := TRUE;
  END_VAR

  RESOURCE resource1 ON PLC
    TASK task0(INTERVAL := T#50ms,PRIORITY := 0);
    PROGRAM instance0 WITH task0 : plc_prg;
  END_RESOURCE
END_CONFIGURATION
