"""
OPCUA to ERP5 OPCUA Document setter / getter glue script.
"""

import json
from erp5.component.module.Log import log

def convertNodeValue(node_id, node_value, type_data):
  """
  Based on type_data convert to proper Python type.
  """
  if "VariantType=<VariantType.String:" in type_data:
    # string
    node_value = str(node_value)
  elif "VariantType=<VariantType.Float:" in type_data:
    node_value = float(node_value)
  elif "VariantType=<VariantType.Int64:" in type_data:
    node_value = int(node_value)
   
  return node_value

# XXX: what should be the OPCUA container?
if default_opcua_document is None:
  default_id = "1"
  default_opcua_document = context.opcua_document_module.get(default_id, None)
  if default_opcua_document is None:
    default_opcua_document = context.opcua_document_module.newContent(
                                                             title = "Default",
                                                             portal_type = "OPCUA Document",
                                                             id = default_id)

# do selection of operation in a REST fashion based in HTTP method
if http_method is None:
  http_method = context.REQUEST.method

if http_method == "GET":
  # assume read request, return  what was saved.
  return json.dumps(default_opcua_document.getNodeDict())
elif http_method == "POST":
  # assume write request
  if data is None:
    try:
      data = context.REQUEST.data
    except AttributeError as e:
      log("Warning: 'data' is missing from request.")
      raise e
  
  data = json.loads(data)
  if 'node' in data.keys():
    # log only set requests for now
    node_id = data['node']
    node_value = data['val']
    # introspect type of the value
    type_data = data["data"]
    
    # set to  "ERP5 OPCUA Document" but only if it's not a None value
    if node_value is not None and node_value != "None":
      node_dict = default_opcua_document.getNodeDict()
      node_dict[node_id] = convertNodeValue(node_id, node_value, type_data)
      default_opcua_document.setNodeDict(node_dict)
      log("Changed = %s" %default_opcua_document.getNodeDict())

  return json.dumps(default_opcua_document.getNodeDict())
