import socket
import struct
import sys
from threading import *
import time

host = "192.168.2.1"
port = 8000
one_microsecond = 1 / 1000000.
multicast_group = '224.3.29.71'
server_address = ('', 10000)
timeout = int(sys.argv[1])
samples_count = int(sys.argv[2])

# send to edge server unicast keep-alive messages
def send_msg():
  while True:
    msg = str(int(time.time() * 1000000))
    s.send(msg.encode("utf-8"))
    print "\t-> %s (unicast)" %msg
    time.sleep(timeout * one_microsecond)

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((host,port))
send_thread = Thread(target = send_msg)
send_thread.daemon = True
send_thread.start()
#s.close()

# Subscribe to UDP datagrams published from edge server
sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock.bind(server_address)
# Tell the operating system to add the socket to the multicast group
# on all interfaces.
group = socket.inet_aton(multicast_group)
mreq = struct.pack('4sL', group, socket.INADDR_ANY)
sock.setsockopt(socket.IPPROTO_IP, socket.IP_ADD_MEMBERSHIP, mreq)

last_micro_second = 0
i = 0
l = []
while i < samples_count:
    data, address = sock.recvfrom(1024)
    current_micro_second = int(data)
    diff = current_micro_second - last_micro_second
    last_micro_second = current_micro_second
    if i > 0:
      # omit first cycle as we care for diff between cycles
      l.append(str(diff))
    i += 1

# save to file
hostname = socket.gethostname()
f = open("report-%s.csv" %hostname, "w")
text = "\n".join(l)
f.write(text)
f.close()
