import socket
import struct
import sys, time
from threading import *

one_microsecond = 1 / 1000000.0
host = "192.168.2.1"
port = 8000
multicast_group = ('224.3.29.71', 10000)
timeout = int(sys.argv[1])

# open socket unicast port for connection from couplers
serversocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
serversocket.bind((host, port))
serversocket.listen(5)

def receive_msg():
  conn, addr = serversocket.accept()
  while True:
    try:
      msg = conn.recv(1024).decode("utf8")
      print "\t<- %s (unicast)" %msg
    except OSError as error:
      return error

receive_thread = Thread(target=receive_msg)
receive_thread.daemon = True
receive_thread.start()
print  "Started unicast keep-alive server"

print "Start sending UDP keep-alive datagrams"
sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
# Set the time-to-live for messages to 1 so they do not go past the
# local network segment.
ttl = struct.pack('b', 1)
sock.setsockopt(socket.IPPROTO_IP, socket.IP_MULTICAST_TTL, ttl)
last_micro_seconds = int(time.time() * 1000000)

# send over UDP keep-alive messages
while True:
    micro_seconds = int(time.time() * 1000000)
    diff = micro_seconds - last_micro_seconds
    last_micro_seconds = micro_seconds
    message = str(micro_seconds)
    print "-> %s (udp)" %message
    sent = sock.sendto(message, multicast_group)
    time.sleep(timeout * one_microsecond) # wait interval
 
sock.close()
