"""
Setup a coupler (in virtual mode) and Beremiz IDE / runtime on a test VM.
"""

computer_id = "COMP-4079"
computer_title = "k2-osie-debian11"

# Beremiz IDE
release = "/opt/slapos.git/software/beremiz-ide/software.cfg"
supply(release, computer_id)
partition_parameter_kw = {}
filter_kw = {"computer_guid": computer_id}
request(
  software_release = release,
  partition_reference = '%s.Beremiz.IDE-1' %computer_title,
  partition_parameter_kw = partition_parameter_kw,
  filter_kw = filter_kw)

# coupler
release = "/opt/slapos.git/software/osie-coupler/software-dev.cfg"
supply(release, computer_id)
partition_parameter_kw = {"mode": 1, # virtual
                          "network_interface": "ens3" # XXX: should not be needed (bug)
                          }
filter_kw = {"computer_guid": computer_id}
request(
  software_release = release,
  partition_reference = '%s.coupler-1' %computer_title,
  partition_parameter_kw = partition_parameter_kw,
  filter_kw = filter_kw)

# beremiz runtime
release = "/opt/slapos.git/software/beremiz-runtime/software.cfg"
supply(release, computer_id)
filter_kw = {"computer_guid": computer_id}
partition_parameter_kw = {
  "runtime_plc_url": "https://lab.nexedi.com/nexedi/osie/raw/master/Beremiz/beremiz_test_opc_ua/bin/beremiz_test_opc_ua.tgz"}
request(
  software_release = release,
  partition_reference = '%s.runtime-1' %computer_title,
  partition_parameter_kw = partition_parameter_kw,
  filter_kw = filter_kw)

# fluentd (gateway!)
release = "/opt/slapos.git/software/fluentd/software.cfg"
supply(release, computer_id)
filter_kw = {"computer_guid": computer_id}
partition_parameter_kw = {}
request(
  software_release = release,
  partition_reference = '%s.fluentd-gateway-1' %computer_title,
  partition_parameter_kw = partition_parameter_kw,
  filter_kw = filter_kw)

# fluent-bit (MQTT broker!)
release = "/opt/slapos.git/software/fluent-bit/software.cfg"
supply(release, computer_id)
filter_kw = {"computer_guid": computer_id}
partition_parameter_kw = {}
request(
  software_release = release,
  partition_reference = '%s.fluentbit-broker-1' %computer_title,
  partition_parameter_kw = partition_parameter_kw,
  filter_kw = filter_kw)
