# Unit Tests

## Framework 

Criterion: https://github.com/Snaipe/Criterion

## Criterion installation for Ubuntu (>=21.04)/Debian (>=11)

apt-get install libcriterion-dev

## Compile open62541
```
ivan@t580:~$ git clone https://github.com/open62541/open62541.git
ivan@t580:~$  cd open62541/
ivan@t580:~/open62541$ git checkout v1.3.3
ivan@t580:~/open62541$  git submodule update --init --recursive
ivan@t580:~/open62541$  mkdir build && cd build
ivan@t580:~/open62541/build$  cmake -DBUILD_SHARED_LIBS=ON \
                                    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
                                    -DUA_NAMESPACE_ZERO=REDUCED \
                                    -DUA_ENABLE_AMALGAMATION=OFF \
                                    -DUA_ENABLE_PUBSUB=ON \
                                    ..

ivan@t580:~/open62541/build$ make -j 7
ivan@t580:~/open62541/build$ sudo make install
```

## Compile
```
ivan@t580:~/repos/nexedi/osie/tests/unit_tests$ make all
```

## Execute Tests
For `test_common` to execute:
```
ivan@t580:~/repos/nexedi/osie/tests/unit_tests/build$ export LD_LIBRARY_PATH=/usr/local/lib
ivan@t580:~/repos/nexedi/osie/tests/unit_tests/build$ /test_common
```

For `test_common` to execute and get a `tap` conform output execute:
```
ivan@t580:~/repos/nexedi/osie/tests/unit_tests/build$ /test_common --tap=test.tap
```
